<!DOCTYPE html>
<html>
  <head>
    <title>Demo Guide: Elasticsearch Engineer I</title>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon">
    <link rel="stylesheet" href="includes/elastic_training.css">
    <link rel="stylesheet" href="../../../../commons/instructions/includes/elastic_training.css">
  </head>

  <body>
    <img class="logo" src="images/elastic-logo.svg" width="300">
    <div class="header">Demo Guide: Elasticsearch Engineer I</div>
    <ul>
      <li><a href="#about">About</a></li>
      <li><a href="#demo1">Demo 1: Importing Blogs from PostgreSQL</a></li>
      <li><a href="#demo2">Demo 2: Ingesting and Analyzing Blog Requests</a></li>
    </ul>

    <hr/> <!-- ********************************************************** -->

    <div class="about">
      <a name="about"></a>
        <h2>About</h2>
      <p><strong>NOTE:</strong> the structure of the VM is:
      <ul>
        <li><kbd>datasets</kbd>:  contains the data used in the labs and lecture</li>
      </ul>
    </div>

    <div class="demo1">
      <a name="demo1"></a>
      <h2>Demo 1: Importing Blogs from PostgreSQL</h2>
      <p><b>Objective</b>: In this demo, we are going to show off the Elastic Stack search capabilities. We will work with a common use case where a company has a Relational Database as the source of truth but wants to use Elasticsearch as a search engine.<br/>
      The demo starts by showing the current data in PostgreSQL. Then we will use Logstash to extract data from PostgreSQL and index it to Elasticsearch. Finally, we will show the website built on top of Elasticsearch.</p>

      <ol>
        <li>
          <strong>BEFORE THE DEMO</strong>, you need to install the postgres client to connect to the database. Change to the <kbd>root</kbd> user (password: <kbd>password</kbd>) and install it.
            <pre class="bash">su -</pre>
            <pre class="bash">apt-get install postgresql</pre>
        </li>
        <li>
          Start the demo by showing the current data in PostgreSQL. Log in to PostgreSQL (password: password) and execute the following query.
          <pre class="bash">psql -U 'postgres' -h db_server</pre>
          <pre><code>SELECT * FROM blogs LIMIT 1;</code></pre>
        </li>
        <li>
          SQL world is now covered, so lets dive into the Elasticsearch world :)
          First stop is starting Elasticsearch and making sure it is running:
          <pre class="bash">ssh server1</pre>
          <pre class="bash">tar -zxf elasticsearch-6.3.1.tar.gz</pre>
          <pre class="bash">elasticsearch/bin/elasticsearch -E network.host=0.0.0.0</pre>
          <pre class="bash">curl server1:9200</pre>
        </li>
        <li>
          Next, let's look into the Logstash config file. It is a simple configuration and you must not invest a lot of time here. Give them the idea of - input, filter, and output - and what is the event pipeline.
          <pre class="bash">ssh server1</pre>
          <pre class="bash">vim blogs_sql.conf</pre>
        </li>
        <li>
          Great! Now that they know what logstash will do, let's run it and see if we have the data in Elasticsearch!
          <pre class="bash">./logstash/bin/logstash -f blogs_sql.conf</pre>
          <pre class="bash">curl server1:9200/_cat/indices</pre>
        </li>
        <li>
          Perfect! Next, we will show students the search page with Elasticsearch results. Make sure to show them the query that is actually being executed. Make sure to highlight that we are using the out of the box experience and we did not change anything. Results are highlighted, we can easily build facets, speed, and result quality with scoring.

          <img src="images/demo_01.png">
        </li>
      </ol>
      <h3>End of Demo 1</h3>
      <hr/>
    </div>

    <!-- ******************************************************************************* -->

    <div class="demo2">
      <a name="demo2"></a>
      <h2>Demo 2: Ingesting and Analyzing Blog Requests</h2>
      <p><b>Objective</b>: In this demo, we are going to show off the Elastic Stack for the logging use case. We will work with a common use case where a company has a website and they want to analyze user requests.<br/>
      The demo starts by showing the current data, a bunch of log files where each line is a user request in a JSON format. Then we will use Filebeat to extract data from those files and index it to Elasticsearch. Finally, we will show how we can use Kibana to build visualizations and a dashboard. Finally we will show a complete pre-built dashboard.</p>

      <ol>
        <li>
          We will start the demo by showing the dataset. Open one of the log files and show to students how a log line looks like. Don't go into too many details about JSON or what happens internally as we will explain those later. Highlight the fact that all the data is already structured and that in some cases you need to transform unstructured data into structured. <a href="https://www.elastic.co/guide/en/beats/filebeat/current/filebeat-modules-overview.html">Filebeat</a> and <a href="https://www.elastic.co/guide/en/logstash/current/logstash-modules.html">Logstash</a> modules are a good follow up if students are interested.
          <pre class="bash">tar -zxf blog_access_logs.tar.gz</pre>
          <pre class="bash">vim datasets/blog_access_logs_s1/access_logs-2017-04-01.log</pre>
        </li>
        <li>
          Next step of the demo is Filebeat. Show them the config file and without going into much detail explain prospectors are the input and Elasticsearch is the output. So, basically we are monitoring all files that match <kbd>paths</kbd> and for each line we are writing a document to Elasticsearch.
          <pre class="bash">vim scripts/filebeat.yml</pre>
        </li>
        <li>
          Let's get data flowing :) Start Filebeat and check if documents are in Elasticsearch. You should have ~1.7M docs.
          <pre class="bash">cd filebeat
./filebeat</pre>
          <pre class="bash">curl localhost:9200/_count
curl localhost:9200/_search</pre>
        </li>
        <li>
          Now that we have data in Elasticsearch, we should analyze it using Kibana. First start Kibana (make sure to have started your kibana before so the first startup does not take a long time):
          <pre class="bash">./kibana/bin/kibana</pre>
        </li>
        <li>
          Now navigate to discover and show the data range from 2017-04 to 2017-09 (<kbd>Last Year</kbd> in the quick time picker should do the trick). <b>Don't waste time in Discover!</b> Go to Visualize and build two different visualizations of your choice. Here are some ideas:
          <ul>
            <li>horizontal bar chart on response code</li>
            <li>pie chart on country</li>
            <li>date histogram by response code</li>
          </ul>
        <li>
          It is time to add those visualizations into a dashboard. Rearrange and resize charts. Finally navigate to the pre-built dashboard and show some interesting features like filter, query, drill down.
          Finish the demo explaining that the idea is to have filebeat collect live data that is being generated and that we should have the dashboard refresh every X seconds. Create a new file with a new log entry with the current time and check the interface for the updated doc. <b>Make sure to update the date.</b>
          <pre class="bash">echo '{"@timestamp": "2018-XX-XX","status_code":200,"method":"GET","host":"test"}' > datasets/blog_access_logs_s1/access_logs-2018-XX-XX.log</pre>
        </li>
      </ol>
      <h3>End of Demo 2</h3>
      <hr/>
    </div>

    <!-- **************************************************************** -->

    <p>© Elasticsearch BV 2015-2019. All rights reserved. Decompiling, copying, publishing and/or distribution without written consent of Elasticsearch BV is strictly prohibited.</p>
  </body>
</html>

